'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @category controls
 * @component label
 * @variations collab-ui-react
 */

var Label = function Label(_ref) {
  var className = _ref.className,
      label = _ref.label,
      htmlFor = _ref.htmlFor;

  return _react2.default.createElement(
    'label',
    { className: className, htmlFor: htmlFor },
    _react2.default.createElement(
      'span',
      null,
      label
    )
  );
};

Label.defaultProps = {
  className: ''
};

Label.displayName = 'Label';

exports.default = Label;

/**
* @name Default Label
* @description Labels are useful.
*
* @category controls
* @component label
* @section default
*
* @js

export default function Default() {
  return (
    <div className='row'>
      <Label
        htmlFor='label1'
        label='Default Label'
      />
    </div>
  );
}

**/

module.exports = exports['default'];